"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var actionCreators_1 = require("../../actionCreators");
var defaultOptions_1 = __importDefault(require("../../defaultOptions"));
var CellResizeUtils_1 = require("../../Utils/CellResizeUtils");
var ComponentUtils_1 = require("../../Utils/ComponentUtils");
var PropsUtils_1 = require("../../Utils/PropsUtils");
var SortUtils_1 = require("../../Utils/SortUtils");
var HeadCellContent_1 = __importDefault(require("../HeadCellContent/HeadCellContent"));
var HeadCellResize_1 = __importDefault(require("../HeadCellResize/HeadCellResize"));
var HeadCell = function (props) {
    var childComponents = props.childComponents, colSpan = props.colSpan, column = props.column, _a = props.column, style = _a.style, isResizable = _a.isResizable, key = _a.key, columnReordering = props.columnReordering, columnResizing = props.columnResizing, dispatch = props.dispatch, hasChildren = props.hasChildren, isGrouped = props.isGrouped, rowSpan = props.rowSpan, sortingMode = props.sortingMode;
    var headCell = props.childComponents.headCell;
    if (columnReordering) {
        var reorderedRowProps = (0, PropsUtils_1.getDraggableProps)(key, dispatch, actionCreators_1.reorderColumns, defaultOptions_1.default.css.draggedColumn, defaultOptions_1.default.css.dragOverColumn);
        headCell = (0, ComponentUtils_1.addElementAttributes)(reorderedRowProps, props, headCell);
    }
    var _b = (0, ComponentUtils_1.getElementCustomization)({
        className: "".concat(defaultOptions_1.default.css.theadCell, " ").concat(defaultOptions_1.default.css.theadCellHeight, " ").concat(defaultOptions_1.default.css.theadFixed, " ").concat(defaultOptions_1.default.css.theadBackground, " ").concat((0, SortUtils_1.isSortingEnabled)(sortingMode) ? 'ka-pointer' : '', " ").concat(isGrouped ? 'ka-thead-grouped-cell' : ''),
        colSpan: colSpan,
        rowSpan: rowSpan,
        scope: 'col',
        style: style,
        id: key,
    }, props, headCell), elementAttributes = _b.elementAttributes, content = _b.content;
    return (React.createElement("th", __assign({}, elementAttributes),
        React.createElement("div", { className: defaultOptions_1.default.css.theadCellWrapper },
            React.createElement("div", { className: defaultOptions_1.default.css.theadCellContentWrapper }, content || React.createElement(HeadCellContent_1.default, __assign({}, props))),
            (0, CellResizeUtils_1.isCellResizeShown)(isResizable, columnResizing) && !hasChildren && (React.createElement(HeadCellResize_1.default, { column: column, dispatch: dispatch, childComponents: childComponents })))));
};
exports.default = HeadCell;
